---
title: ResizeObserver()
slug: Web/API/ResizeObserver/ResizeObserver
tags:
  - API
  - Constructor
  - Reference
  - Resize Observer API
  - ResizeObserver
  - observers
---
<div>{{APIRef("Resize Observer API")}}</div>

<p class="summary">The <strong><code>ResizeObserver</code></strong> constructor creates a new {{domxref("ResizeObserver")}} object, which can be used to report changes to the content or border box of an {{domxref('Element')}} or the bounding box of an {{domxref('SVGElement')}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>ResizeObserver</var> = new ResizeObserver(<var>callback</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>callback</var></code></dt>
 <dd>The function called whenever an observed resize occurs. The function is called with two parameters:
 <dl>
  <dt><code><var>entries</var></code></dt>
  <dd>An array of {{domxref('ResizeObserverEntry')}} objects that can be used to access the new dimensions of the element after each change.</dd>
  <dt><code><var>observer</var></code></dt>
  <dd>A reference to the <code>ResizeObserver</code> itself, so it will definitely be accessible from inside the callback, should you need it. This could be used for example to automatically unobserve the observer when a certain condition is reached, but you can omit it if you don't need it.</dd>
 </dl>

 <p>The callback will generally follow a pattern along the lines of:</p>

 <pre class="brush: js notranslate">function(entries, observer) {
  for (let entry of entries) {
    // Do something to each entry
    // and possibly something to the observer itself
  }
}</pre>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following snippet is taken from the <a href="https://mdn.github.io/dom-examples/resize-observer/resize-observer-text.html">resize-observer-text.html</a> (<a href="https://github.com/mdn/dom-examples/blob/master/resize-observer/resize-observer-text.html">see source</a>) example:</p>

<pre class="brush: js notranslate">const resizeObserver = new ResizeObserver(entries =&gt; {
  for (let entry of entries) {
    if(entry.contentBoxSize) {
      // Checking for chrome as using a non-standard array
      if (entry.contentBoxSize[0]) {
        h1Elem.style.fontSize = Math.max(1.5, entry.contentBoxSize[0].inlineSize/200) + 'rem';
        pElem.style.fontSize = Math.max(1, entry.contentBoxSize[0].inlineSize/600) + 'rem';
      } else {
        h1Elem.style.fontSize = Math.max(1.5, entry.contentBoxSize.inlineSize/200) + 'rem';
        pElem.style.fontSize = Math.max(1, entry.contentBoxSize.inlineSize/600) + 'rem';
      }
    } else {
      h1Elem.style.fontSize = Math.max(1.5, entry.contentRect.width/200) + 'rem';
      pElem.style.fontSize = Math.max(1, entry.contentRect.width/600) + 'rem';
    }
  }
  console.log('Size changed');
});

resizeObserver.observe(divElem);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Resize Observer','#dom-resizeobserver-resizeobserver','ResizeObserver')}}</td>
   <td>{{Spec2('Resize Observer')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ResizeObserver.ResizeObserver")}}</p>
